SystemOrganization addCategory: #PharoKernel!

Object subclass: #PharoKernel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoKernel'!

!PharoKernel methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 12:45'!
downloadPackagesNamed: listOfPackageNames fromRepositoryNamed: aRepositoryName

	ZnConnectionTimeout value: 300 during: [
	listOfPackageNames do: [:packageName |
	  FileStream forceNewFileNamed: (packageName, '.st') do: [:file |
	    file nextPutAll: (ScriptLoader latestSource: packageName location: aRepositoryName)]].
	].

	
	
	! !

!PharoKernel methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 12:21'!
installPackagesNamed: aListOfPackageNames
	(aListOfPackageNames collect: [:each | each , '.st']) 
		do: [:each | FileStream readOnlyFileNamed: each do: [:file | file fileInSilently ].]
	! !

!PharoKernel methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 12:19'!
loadPackagesNamed: aListOfPackageNames fromRepositoryNamed: aRepositoryName
	
	self downloadPackagesNamed: aListOfPackageNames fromRepositoryNamed: aRepositoryName.
	self installPackagesNamed: aListOfPackageNames.
	! !

!PharoKernel methodsFor: 'logging' stamp: 'MarianoMartinezPeck 4/28/2012 12:27'!
log: aString
	FileStream stdout lf; nextPutAll: aString; lf.! !

PharoKernel subclass: #PharoKernelExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoKernel'!

!PharoKernelExporter class methodsFor: 'instance-creation' stamp: 'MarianoMartinezPeck 4/28/2012 12:11'!
exportCore
	self new exportCore! !

!PharoKernelExporter methodsFor: 'exporting' stamp: 'MarianoMartinezPeck 4/28/2012 14:29'!
exportCore
	| timeToRun |
	self loadFuel.
	timeToRun := [self serializeClassVariablesAndFonts.
	self exportRing.
	self exportGofer.
	self exportPharoCore.] timeToRun.
	self log: 'PharoCore exported in ', timeToRun asString, ' miliseconds'.! !

!PharoKernelExporter methodsFor: 'exporting' stamp: 'MarianoMartinezPeck 4/28/2012 14:11'!
exportGofer

	| packagesNames |
	self log: 'Exporting Gofer packages'.
	packagesNames := self listOfGoferPackages.
	self exportPackagesNamed: packagesNames toFileName: 'gofer.fuel'.
	self log: 'Finished'.! !

!PharoKernelExporter methodsFor: 'private' stamp: 'MarianoMartinezPeck 4/28/2012 12:31'!
exportPackagesNamed: packageNames toFileName: aFileName
	FileStream forceNewFileNamed: aFileName do: [:aStream |
       aStream binary.
       FLPackageStore new storeOn: aStream packages: packageNames.].
! !

!PharoKernelExporter methodsFor: 'exporting' stamp: 'MarianoMartinezPeck 4/28/2012 14:12'!
exportPharoCore

	| packagesNames |
	self log: 'Exporting PharoCore packages'.
	packagesNames := self listOfPharoCorePackages.
	self exportPackagesNamed: packagesNames toFileName: 'pharo-core.fuel'.
	self log: 'Finished'.! !

!PharoKernelExporter methodsFor: 'exporting' stamp: 'MarianoMartinezPeck 4/28/2012 14:07'!
exportRing

	self log: 'Exporting Ring packages'.
	self exportPackagesNamed: #('Ring-Core-Containers' 'Ring-Core-Kernel' ) toFileName: 'ring.fuel'.
	self log: 'Finished'.! !

!PharoKernelExporter methodsFor: 'exporting' stamp: 'MarianoMartinezPeck 4/28/2012 14:11'!
listOfGoferPackages
^ 'Network-Kernel
Network-MIME
Network-UUID
Network-Url
Network-URI
Network-Protocols
PackageInfo
System-FileRegistry
System-Announcements
Monticello
MonticelloConfigurations
Zinc-HTTP
Zinc-Patch-HTTPSocket
Settings-Network
Settings-Monticello
Gofer-Core' lines
! !

!PharoKernelExporter methodsFor: 'exporting' stamp: 'MarianoMartinezPeck 4/28/2012 14:12'!
listOfPharoCorePackages
^ 'Announcements-View
Announcements-Help
Announcements-Tests-Core
Balloon
BalloonTests
Collections-Arithmetic
Collections-Native
Collections-Traits
CollectionsTests
Compatibility
CompilerTests
CompressionTests
Deprecated14
EmergencyEvaluator
EventModel
FileSystem-AnsiStreams
FileSystem-Core
FileSystem-Disk
FileSystem-Memory
FileSystem-Tests-AnsiStreams
FileSystem-Tests-Core
FileSystem-Tests-Disk
FileSystem-Tests-Memory
FileSystem-Zip
FixUnderscores
FreeType
FreeTypeTests
Gofer-Tests
Graphics-External
Graphics-Files
Graphics-Fonts
Graphics-Resources
Graphics-Support
Graphics-Tests
Graphics-Text
HelpSystem-Core
HelpSystem-Tests
HostMenus
KernelTests
NECompletion
NOCompletion
MenuRegistration
MonticelloConfigurations
MonticelloGUI
MonticelloMocks
Morphic
MorphicTests
Multilingual-Tests
Network-Mail
Network-RFC822
Network-RemoteDirectory
NetworkTests
NonInteractiveTranscript
Polymorph-EventEnhancements
Polymorph-Geometry
Polymorph-TaskbarIcons
Polymorph-Tools-Diff
Polymorph-Widgets
RecentSubmissions
Regex-Core
Regex-Help
Regex-Tests-Core
Ring-Tests-Containers
Ring-Tests-Kernel
SUnit-Core
SUnit-Help
SUnit-Tests
SUnit-UI
ScriptLoader14
Settings-Compiler
Settings-Display
Settings-FreeType
Settings-Graphics
Settings-Kernel
Settings-Monticello
Settings-Network
Settings-Polymorph
Settings-System
Settings-Tools
Shout
ShoutTests
StartupPreferences
System-Applications
System-Download
System-FilePackage
System-Hashing
System-History
System-Installers
System-Serial Port
System-Settings
System-Sound
System-Text
System-Tools
Tests
Tools
ToolsTest
TrueType
UI-Basic
Zinc-Tests' lines.! !

!PharoKernelExporter methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 12:26'!
loadFuel
	self log: 'Loading and installing Fuel from repository'.
	self loadPackagesNamed:  #( 'Fuel' 'FuelMetalevel' 'FuelPackageLoader') fromRepositoryNamed: 'http://ss3.gemstone.com/ss/Fuel'.
	self log: 'Finished'.
	
	! !

!PharoKernelExporter methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 4/28/2012 12:24'!
serialize: anObject toFileNamed: aFileName
	FLSerializer serialize: anObject toFileNamed: aFileName.! !

!PharoKernelExporter methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 4/28/2012 12:26'!
serializeClassVariablesAndFonts
	self log: 'Serializing class variables and fonts'.
	self serialize: (TextStyle named: 'Bitmap DejaVu Sans') toFileNamed: 'dejavu.fuel'.
	self serialize: (Unicode classPool at: #DecimalProperty) toFileNamed: 'decimalProperty.fuel'.
	self serialize: (Unicode classPool at: #GeneralCategory) toFileNamed: 'generalCategory.fuel'.
	self serialize: (UCSTable classPool at: #GB2312Table) toFileNamed: 'gb2312Table.fuel'.
	self serialize: (UCSTable classPool at: #JISX0208Table) toFileNamed: '#jisX0208Table.fuel'.
	self serialize: (UCSTable classPool at: #KSX1001Table) toFileNamed: '#ksx1001Table.fuel'.
	self log: 'Finished'.! !

!PackageInfo methodsFor: '*PharoKernel' stamp: 'MarianoMartinezPeck 4/28/2012 12:12'!
extensionMethods
	^ (Smalltalk allClassesAndTraits, (Smalltalk allClasses collect: [:c | c class])) gather: [:classOrTrait | self extensionMethodsForClass: classOrTrait]! !
